import { HttpClient, HTTP_INTERCEPTORS } from '@angular/common/http';
import { Injectable, EventEmitter, NgModule } from '@angular/core';
import { MappedGetAll, MappedHttpGet, MappedHttpPostLocation } from 'totvs-log-base-foundation';
import { of } from 'rxjs';
import { map } from 'rxjs/operators';
import { Router } from '@angular/router';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Classe de configuração para gerenciamento de Unidade
 */
var  /**
 * Classe de configuração para gerenciamento de Unidade
 */
UnidadeConfigBase = /** @class */ (function () {
    function UnidadeConfigBase() {
    }
    return UnidadeConfigBase;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var UnidadeGetAllService = /** @class */ (function () {
    function UnidadeGetAllService(httpClient, unidadeConfig) {
        var _this = this;
        this.httpClient = httpClient;
        unidadeConfig.urlUnidadeQuery.subscribe((/**
         * @param {?} urlUnidadeQuery
         * @return {?}
         */
        function (urlUnidadeQuery) {
            _this._urlGetAll = urlUnidadeQuery + "/unidades";
            _this.mappedGetAll = new MappedGetAll(_this.httpClient, _this.urlGetAll, {
                MapTo: (/**
                 * @param {?} unidade
                 * @return {?}
                 */
                function (unidade) { return unidade; })
            }).withTotvsNoErrorHeader();
        }));
    }
    Object.defineProperty(UnidadeGetAllService.prototype, "urlGetAll", {
        get: /**
         * @return {?}
         */
        function () {
            return this._urlGetAll;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(UnidadeGetAllService.prototype, "page", {
        get: /**
         * @return {?}
         */
        function () {
            return this.mappedGetAll.page;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(UnidadeGetAllService.prototype, "pageSize", {
        get: /**
         * @return {?}
         */
        function () {
            return this.mappedGetAll.pageSize;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(UnidadeGetAllService.prototype, "hasNext", {
        get: /**
         * @return {?}
         */
        function () {
            return this.mappedGetAll.hasNext;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(UnidadeGetAllService.prototype, "items", {
        get: /**
         * @return {?}
         */
        function () {
            return this.mappedGetAll.items;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    UnidadeGetAllService.prototype.reset = /**
     * @return {?}
     */
    function () {
        return this.mappedGetAll.reset();
    };
    /**
     * @return {?}
     */
    UnidadeGetAllService.prototype.more = /**
     * @return {?}
     */
    function () {
        return this.mappedGetAll.more();
    };
    /**
     * @return {?}
     */
    UnidadeGetAllService.prototype.getAll = /**
     * @return {?}
     */
    function () {
        return this.reset();
    };
    UnidadeGetAllService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    UnidadeGetAllService.ctorParameters = function () { return [
        { type: HttpClient },
        { type: UnidadeConfigBase }
    ]; };
    return UnidadeGetAllService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var UnidadeGetByIdService = /** @class */ (function () {
    function UnidadeGetByIdService(httpClient, unidadeConfig) {
        var _this = this;
        this.httpClient = httpClient;
        unidadeConfig.urlUnidadeQuery.subscribe((/**
         * @param {?} urlUnidadeQuery
         * @return {?}
         */
        function (urlUnidadeQuery) {
            _this._url = urlUnidadeQuery + "/unidades/{0}";
            _this.mappedById = new MappedHttpGet(_this.url, {
                MapTo: (/**
                 * @param {?} unidade
                 * @return {?}
                 */
                function (unidade) { return unidade; })
            }, _this.httpClient).withTotvsNoErrorHeader();
        }));
    }
    Object.defineProperty(UnidadeGetByIdService.prototype, "url", {
        get: /**
         * @return {?}
         */
        function () {
            return this._url;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} unidadeId
     * @return {?}
     */
    UnidadeGetByIdService.prototype.Get = /**
     * @param {?} unidadeId
     * @return {?}
     */
    function (unidadeId) {
        return this.mappedById.Get(unidadeId);
    };
    UnidadeGetByIdService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    UnidadeGetByIdService.ctorParameters = function () { return [
        { type: HttpClient },
        { type: UnidadeConfigBase }
    ]; };
    return UnidadeGetByIdService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var UnidadeService = /** @class */ (function () {
    function UnidadeService(unidadeGetAll) {
        this.unidadeGetAll = unidadeGetAll;
        this._eventoUnidadeCorrenteDefinida = new EventEmitter();
    }
    Object.defineProperty(UnidadeService.prototype, "unidadeCorrente", {
        /** Unidade corrente */
        get: /**
         * Unidade corrente
         * @return {?}
         */
        function () {
            return this._unidadeCorrente;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(UnidadeService.prototype, "eventoUnidadeCorrenteDefinida", {
        /** Evento que é emitido quando a unidade corrente é definida */
        get: /**
         * Evento que é emitido quando a unidade corrente é definida
         * @return {?}
         */
        function () {
            return this._eventoUnidadeCorrenteDefinida;
        },
        enumerable: true,
        configurable: true
    });
    /** Método que define a unidade corrente */
    /**
     * Método que define a unidade corrente
     * @param {?} unidade
     * @return {?}
     */
    UnidadeService.prototype.definirUnidadeCorrente = /**
     * Método que define a unidade corrente
     * @param {?} unidade
     * @return {?}
     */
    function (unidade) {
        this._unidadeCorrente = unidade;
        this.eventoUnidadeCorrenteDefinida.emit(this._unidadeCorrente);
    };
    /** Método que busca e devolve a unidade corrente se não estiver definida */
    /**
     * Método que busca e devolve a unidade corrente se não estiver definida
     * @return {?}
     */
    UnidadeService.prototype.buscarUnidadeCorrente = /**
     * Método que busca e devolve a unidade corrente se não estiver definida
     * @return {?}
     */
    function () {
        if (this.unidadeCorrente) {
            return of(this.unidadeCorrente);
        }
        else {
            return this.unidadeGetAll.reset().pipe(map((/**
             * @param {?} unidades
             * @return {?}
             */
            function (unidades) { return (unidades && unidades.length > 0) ? unidades[0] : undefined; })));
        }
    };
    UnidadeService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    UnidadeService.ctorParameters = function () { return [
        { type: UnidadeGetAllService }
    ]; };
    return UnidadeService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Constante usado nas requisições para que a unidadeId seja inserida no filtro
 * @type {?}
 */
var SL_UNIDADE_ID_HEADER_PARAM = 'X-SL-Unidade-Id';
var UnidadeIdInterceptorService = /** @class */ (function () {
    /**
     * Construtor que injeta o serviço de gerenciamento de unidade
     */
    function UnidadeIdInterceptorService(unidadeService) {
        this.unidadeService = unidadeService;
    }
    /**
     * Implementação da interface de interceptação HTTP
     * que apenas adiciona a requisição o filtro por unidadeId
     */
    /**
     * Implementação da interface de interceptação HTTP
     * que apenas adiciona a requisição o filtro por unidadeId
     * @param {?} request
     * @param {?} next
     * @return {?}
     */
    UnidadeIdInterceptorService.prototype.intercept = /**
     * Implementação da interface de interceptação HTTP
     * que apenas adiciona a requisição o filtro por unidadeId
     * @param {?} request
     * @param {?} next
     * @return {?}
     */
    function (request, next) {
        if (request.headers.has(SL_UNIDADE_ID_HEADER_PARAM) && this.unidadeService.unidadeCorrente) {
            /** @type {?} */
            var params = request.params;
            if (request.method === 'GET') {
                params = params.append('unidadeId', this.unidadeService.unidadeCorrente.id);
            }
            /** @type {?} */
            var body = request.body;
            if (request.method === 'POST' && request.body !== null) {
                body = Object.assign({ unidadeId: this.unidadeService.unidadeCorrente.id }, request.body);
            }
            return next.handle(request.clone({
                headers: request.headers.delete(SL_UNIDADE_ID_HEADER_PARAM),
                params: params,
                body: body
            }));
        }
        else {
            return next.handle(request);
        }
    };
    UnidadeIdInterceptorService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    UnidadeIdInterceptorService.ctorParameters = function () { return [
        { type: UnidadeService }
    ]; };
    return UnidadeIdInterceptorService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var UnidadeIncluirService = /** @class */ (function () {
    function UnidadeIncluirService(httpClient, unidadeConfig) {
        var _this = this;
        this.httpClient = httpClient;
        unidadeConfig.urlUnidade.subscribe((/**
         * @param {?} urlUnidade
         * @return {?}
         */
        function (urlUnidade) {
            _this._url = urlUnidade + "/unidades";
            _this.mapped = new MappedHttpPostLocation(_this.url, {
                MapTo: (/**
                 * @param {?} unidade
                 * @return {?}
                 */
                function (unidade) { return unidade; })
            }, _this.httpClient);
        }));
    }
    Object.defineProperty(UnidadeIncluirService.prototype, "url", {
        get: /**
         * @return {?}
         */
        function () {
            return this._url;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} unidade
     * @return {?}
     */
    UnidadeIncluirService.prototype.Post = /**
     * @param {?} unidade
     * @return {?}
     */
    function (unidade) {
        return this.mapped.Post(unidade);
    };
    UnidadeIncluirService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    UnidadeIncluirService.ctorParameters = function () { return [
        { type: HttpClient },
        { type: UnidadeConfigBase }
    ]; };
    return UnidadeIncluirService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Implementação de guard para identificação da unidade
 */
var UnidadeGuard = /** @class */ (function () {
    function UnidadeGuard(router, servicoUnidade, unidadeConfig) {
        this.router = router;
        this.servicoUnidade = servicoUnidade;
        this.unidadeConfig = unidadeConfig;
    }
    /**
     * @param {?} route
     * @param {?} state
     * @return {?}
     */
    UnidadeGuard.prototype.canActivate = /**
     * @param {?} route
     * @param {?} state
     * @return {?}
     */
    function (route, state) {
        var _this = this;
        return new Promise((/**
         * @param {?} resolve
         * @return {?}
         */
        function (resolve) {
            _this.servicoUnidade.buscarUnidadeCorrente().subscribe((/**
             * @param {?} unidade
             * @return {?}
             */
            function (unidade) {
                if (unidade) {
                    _this.servicoUnidade.definirUnidadeCorrente(unidade);
                    resolve(true);
                }
                else {
                    resolve(_this.navegarParaRotaUnidadeNaoEncontrada(_this.unidadeConfig.rotaUnidadeNaoEncontrada, state.url));
                }
            }), (/**
             * @param {?} error
             * @return {?}
             */
            function (error) {
                console.error(error);
                resolve(_this.navegarParaRotaErroBuscarUnidade(_this.unidadeConfig.rotaErroBuscarUnidade, state.url));
            }));
        }));
    };
    /**
     * @private
     * @param {?} rota
     * @param {?} rotaAtual
     * @return {?}
     */
    UnidadeGuard.prototype.navegarParaRotaUnidadeNaoEncontrada = /**
     * @private
     * @param {?} rota
     * @param {?} rotaAtual
     * @return {?}
     */
    function (rota, rotaAtual) {
        if (rota && rota.trim() !== '' && "/" + rota !== rotaAtual) {
            return this.router.parseUrl("/" + rota);
        }
        else {
            return true;
        }
    };
    /**
     * @private
     * @param {?} rota
     * @param {?} rotaAtual
     * @return {?}
     */
    UnidadeGuard.prototype.navegarParaRotaErroBuscarUnidade = /**
     * @private
     * @param {?} rota
     * @param {?} rotaAtual
     * @return {?}
     */
    function (rota, rotaAtual) {
        if (rota && rota.trim() !== '') {
            if ("/" + rota === rotaAtual) {
                return true;
            }
            else {
                return this.router.parseUrl("/" + rota);
            }
        }
        else {
            return false;
        }
    };
    UnidadeGuard.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    UnidadeGuard.ctorParameters = function () { return [
        { type: Router },
        { type: UnidadeService },
        { type: UnidadeConfigBase }
    ]; };
    return UnidadeGuard;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var SLUnidadeModule = /** @class */ (function () {
    function SLUnidadeModule() {
    }
    /**
     * @return {?}
     */
    SLUnidadeModule.forRoot = /**
     * @return {?}
     */
    function () {
        return {
            ngModule: SLUnidadeModule,
            providers: [
                UnidadeService,
                UnidadeGetAllService,
                UnidadeGetByIdService,
                UnidadeIncluirService,
                UnidadeGuard
            ],
        };
    };
    SLUnidadeModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [],
                    imports: [],
                    providers: [
                        {
                            provide: HTTP_INTERCEPTORS,
                            useClass: UnidadeIdInterceptorService,
                            multi: true
                        }
                    ]
                },] }
    ];
    return SLUnidadeModule;
}());

export { SLUnidadeModule, SL_UNIDADE_ID_HEADER_PARAM, UnidadeConfigBase, UnidadeGetAllService, UnidadeGetByIdService, UnidadeGuard, UnidadeIdInterceptorService, UnidadeIncluirService, UnidadeService };
//# sourceMappingURL=totvs-log-base-foundation-src-sl-unidade.js.map
