import { HttpClient } from '@angular/common/http';
import { Observable } from 'rxjs';
import { IMapper } from './../mappers/mapper.interface';
import { MappedHttp } from './mapped-http';
import { IDeleteEntity } from './verbs/delete-entity.interface';
/**
 * Realiza a operação de Delete para o enpoint informado, mapeando a entidade antes de enviar
 */
export declare class MappedHttpDelete<EntityId> extends MappedHttp implements IDeleteEntity {
    private httpClient;
    /** Propriedade que indica se deve ou não definir o cabeçalho 'X-Portinari-No-Error' */
    private _xTotvsNoError;
    readonly xTotvsNoError: boolean;
    constructor(endpoint: string, httpClient: HttpClient, urlMapper?: IMapper<Array<any>, string>);
    /**
     * Implementação da chamada de deleção de um recurso
     *
     * @returns Deve ser assinado para a deleção ocorrer
     */
    Delete(...params: EntityId[]): Observable<any>;
    /**
     * Retorna a instância definindo o cabeçalho para não apresentar as
     * mensagens de erro conforme padrão do Guia de Implementação de API
     * (X-Portinari-No-Error)
     */
    withTotvsNoErrorHeader(): MappedHttpDelete<EntityId>;
    /** Monta o cabeçalho da requisição */
    private getHeaders;
}
