import { HttpEvent, HttpHandler, HttpInterceptor, HttpRequest } from '@angular/common/http';
import { InjectionToken } from '@angular/core';
import { Observable, OperatorFunction } from 'rxjs';
import { LoadingDefault } from '../../../entities/loading/loading-default';
export declare const DEFAULT_DELAYED_SHOW_LOADING: InjectionToken<number>;
export declare const DEFAULT_HIDE_LOADING_AFTER: InjectionToken<number>;
/**
 * Quando utilizado o loading-interceptor, indica quantas requisições deve aguardar até fechar o loading.
 * utilizar com operadores forkJoin, concat,etc
 * @param requests quantidade de requisições
 */
export declare function makeLoadingOpened(requests?: number): Observable<any>;
/**
 * Quando utilizado o loading-interceptor, indica quantas requisições deve aguardar até fechar o loading.
 * utilizar com .pipe
 * @param requests quantidade de requisições
 */
export declare function keepLoadingOpened<T>(requests?: number): OperatorFunction<T, T>;
export declare class LoadingInterceptorService implements HttpInterceptor {
    protected defaultDelayedShowLoading: number;
    protected defaultHideLoadingAfter: number;
    private loading;
    keepLoadingOpenFor: number;
    constructor(defaultDelayedShowLoading: number, defaultHideLoadingAfter: number, loading: LoadingDefault);
    runningCalls: number;
    intercept(req: HttpRequest<any>, next: HttpHandler): Observable<HttpEvent<any>>;
}
