import { ValidatorFn } from '@angular/forms';
export declare class Validator {
    static readonly CPF_SIZE = 11;
    static readonly PLACA_SIZE = 7;
    static readonly CNPJ_SIZE = 14;
    static readonly MAX_FILE_SIZE_5_MB = 5000000;
    static cpfIsInvalid(cpf: string): boolean;
    static cpfIsValid(stringCPF: string): boolean;
    static cnpjIsInvalid(cnpj: string): boolean;
    static cnpjIsValid(cnpj: any): boolean;
    static cnpjFormatter(cnpj: string): string;
    static cpfFormatter(cpf: string): string;
}
export declare function cpfValidator(): ValidatorFn;
export declare function cnpjValidator(): ValidatorFn;
