import { EventEmitter } from '@angular/core';
import { Observable } from 'rxjs';
import { IUnidade } from './unidade.interface';
/**
 * Interface do serviço de gerenciamento de Unidade
 */
export interface IUnidadeService {
    /** Unidade corrente */
    unidadeCorrente: IUnidade;
    /** Evento que é emitido quando a unidade corrente é definida */
    eventoUnidadeCorrenteDefinida: EventEmitter<IUnidade>;
    /** Método que define a unidade corrente */
    definirUnidadeCorrente(unidade: IUnidade): void;
    /** Método que busca e devolve a unidade corrente se não estiver definida */
    buscarUnidadeCorrente(): Observable<IUnidade>;
}
