import { HttpEvent, HttpHandler, HttpInterceptor, HttpRequest } from '@angular/common/http';
import { Observable } from 'rxjs';
import { UnidadeService } from './unidade.service';
/**
 * Constante usado nas requisições para que a unidadeId seja inserida no filtro
 */
export declare const SL_UNIDADE_ID_HEADER_PARAM = "X-SL-Unidade-Id";
export declare class UnidadeIdInterceptorService implements HttpInterceptor {
    private unidadeService;
    /**
     * Construtor que injeta o serviço de gerenciamento de unidade
     */
    constructor(unidadeService: UnidadeService);
    /**
     * Implementação da interface de interceptação HTTP
     * que apenas adiciona a requisição o filtro por unidadeId
     */
    intercept(request: HttpRequest<any>, next: HttpHandler): Observable<HttpEvent<any>>;
}
