import { EventEmitter } from '@angular/core';
import { Observable } from 'rxjs';
import { IUnidade } from '../entities/unidade.interface';
import { IUnidadeService } from './../entities/unidade-service.interface';
import { UnidadeGetAllService } from './unidade-get-all.service';
export declare class UnidadeService implements IUnidadeService {
    private unidadeGetAll;
    private _unidadeCorrente;
    /** Unidade corrente */
    readonly unidadeCorrente: IUnidade;
    private _eventoUnidadeCorrenteDefinida;
    /** Evento que é emitido quando a unidade corrente é definida */
    readonly eventoUnidadeCorrenteDefinida: EventEmitter<IUnidade>;
    constructor(unidadeGetAll: UnidadeGetAllService);
    /** Método que define a unidade corrente */
    definirUnidadeCorrente(unidade: IUnidade): void;
    /** Método que busca e devolve a unidade corrente se não estiver definida */
    buscarUnidadeCorrente(): Observable<IUnidade>;
}
